vsg: vsg::Builder Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | List of all members
vsg::Builder Class Reference

`#include <Builder.h>`

Inheritance diagram for vsg::Builder:
[legend]
Collaboration diagram for vsg::Builder:
[legend]

## Public Member Functions
| Builder (const Builder &rhs)=delete
Builder & | operator= (const Builder &rhs)=delete
ref_ptr< Node > | createBox (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createCapsule (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createCone (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createCylinder (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createDisk (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createQuad (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createSphere (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< Node > | createHeightField (const GeometryInfo &info={}, const StateInfo &stateInfo={})
ref_ptr< StateGroup > | createStateGroup (const StateInfo &stateInfo={})
void | assignCompileTraversal (ref_ptr< CompileTraversal > ct)
| assign compile traversal to enable compilation.
Public Member Functions inherited from vsg::Inherit< Object, Builder >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
bool | verbose = false
ref_ptr< Options > | options
ref_ptr< SharedObjects > | sharedObjects
ref_ptr< ShaderSet > | shaderSet
ref_ptr< CompileTraversal > | compileTraversal

## Protected Types
using | GeometryMap = std::map<std::pair<GeometryInfo, StateInfo>, ref_ptr<Node>>

## Protected Member Functions
void | transform (const mat4 &matrix, ref_ptr< vec3Array > vertices, ref_ptr< vec3Array > normals)
ref_ptr< Data > | instancePositions (const GeometryInfo &info, uint32_t &instanceCount)
ref_ptr< Data > | instanceColors (const GeometryInfo &info, uint32_t instanceCount)
vec3 | y_texcoord (const StateInfo &info) const
ref_ptr< Node > | decorateAndCompileIfRequired (const GeometryInfo &info, const StateInfo &stateInfo, ref_ptr< Node > node)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Protected Attributes
ref_ptr< ShaderSet > | _flatShadedShaderSet
ref_ptr< ShaderSet > | _phongShaderSet
GeometryMap | _boxes
GeometryMap | _capsules
GeometryMap | _cones
GeometryMap | _cylinders
GeometryMap | _disks
GeometryMap | _quads
GeometryMap | _spheres
GeometryMap | _heightfields
mat4 | identity

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, Builder >
static ref_ptr< Builder > | create (Args &&... args)
static ref_ptr< Builder > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Detailed Description

Builder class that creates subgraphs that can render primitive geometries. Supported shapes are Box, Capsule, Cone, Cylinder, Disk, Quad, Sphere and HeightField. Uses GeometryInfo and StateInfo to guide the geometry's position/size and rendering state.

The documentation for this class was generated from the following file:

- include/vsg/utils/Builder.h